//+------------------------------------------------------------------+
//| 8:27 AM 7/28/2016                             MARibbonFilled.mq4 |
//|                          Copyright  2017-18, WHRoeder@yahoo.com |
//|                                        mailto:WHRoeder@yahoo.com |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property strict
#property copyright     "Copyright  2017-18, WHRoeder@yahoo.com"
#property link          "mailto:WHRoeder@yahoo.com"
#property description   "Two moving averages."
#property description   "Colored by MACD."
#property description   "Filled color ribbon."
#property version       "1.0"
//+------------------------------------------------------------------+
//{ Generic code                                                     |
//+------------------------------------------------------------------+
//{ Typedefs
#define  PRICE double            // A PRICE
#define     PRICE_MAX   EMPTY_VALUE
#define     PRICE_MIN   0.0
#define     CHANGE      PRICE    // Difference of two prices.
#define  INDEX    uint           // Zero based.
   #define  INV_INDEX      UINT_MAX
#define  COUNT    uint           //  One based.
   #define  INV_COUNT      UINT_MAX
#define  MONEY    double
#define  SYMBOL   string
//} Typedefs
template <typename T>
T        MathMax(T a, T b, T c){ return MathMax(a, MathMax(b, c) );  }
template <typename T>
T        MathMin(T a, T b, T c){ return MathMin(a, MathMin(b, c) );  }
template<typename T>
void              swap(T& a, T& b){  T t=a;   a=b;  b=t;  }
string            as_string(ENUM_MA_METHOD p, int len=0){
   string mode_XXX = EnumToString(p);        // MODE_XXX
   return StringSubstr(mode_XXX, 5, len);    // XXX
}
string            as_string(ENUM_APPLIED_PRICE p, int len=0){
   string price_XXX = EnumToString(p);       // PRICE_XXX
   return StringSubstr(price_XXX, 6, len);   // XXX
}
string            as_string(ENUM_TIMEFRAMES period){
   if(period == PERIOD_CURRENT)  period   = (ENUM_TIMEFRAMES) _Period;
   string   period_xxx  = EnumToString(period);                // PERIOD_XXX
   return StringSubstr(period_xxx, 7);                         // XXX
}
void              alert_id(string msg){
   Alert(StringFormat("%s %s %s %s", WindowExpertName(), _Symbol,
                                     as_string(PERIOD_CURRENT), msg) );
}
class    ATR{
 public:
            ATR(COUNT len=14)  : mSymbol(_Symbol), mLength(len),        // cTor
                                 mTF( ENUM_TIMEFRAMES(_Period) ){}
            ATR(ENUM_TIMEFRAMES tf, COUNT len=14)                       // cTor
                               : mSymbol(_Symbol), mLength(len), mTF(tf){}
            ATR(SYMBOL sym, ENUM_TIMEFRAMES tf, COUNT len=14)           // cTor
                               : mSymbol(sym), mLength(len), mTF(tf){}
   PRICE    get(INDEX iBar){  return   iATR(mSymbol, mTF, mLength, iBar);      }
 private:
   SYMBOL               mSymbol;
   COUNT                mLength;
   ENUM_TIMEFRAMES      mTF;
}; // ATR
class    MA{
 public:
            MA(ENUM_MA_METHOD ma, COUNT len=14,                         // cTor
                                             ENUM_APPLIED_PRICE ap=PRICE_CLOSE)
                               : mSymbol(_Symbol), mAP(ap), mLength(len),
                                 mMethod(ma), mTF( ENUM_TIMEFRAMES(_Period) ){}
            MA(ENUM_TIMEFRAMES tf, ENUM_MA_METHOD ma, COUNT len=14,     // cTor
                                             ENUM_APPLIED_PRICE ap=PRICE_CLOSE)
                               : mSymbol(_Symbol), mAP(ap), mLength(len),
                                 mMethod(ma), mTF(tf){}
            MA(SYMBOL sym, ENUM_TIMEFRAMES tf, ENUM_MA_METHOD ma,       // cTor
                              COUNT len=14, ENUM_APPLIED_PRICE ap=PRICE_CLOSE)
                               : mSymbol(sym), mAP(ap), mLength(len),
                                 mMethod(ma), mTF(tf){}
   PRICE    get(INDEX iBar){  return
                           iMA(mSymbol, mTF, mLength, 0, mMethod, mAP, iBar);  }
 private:
   SYMBOL               mSymbol;
   ENUM_APPLIED_PRICE   mAP;
   COUNT                mLength;
   ENUM_MA_METHOD       mMethod;
   ENUM_TIMEFRAMES      mTF;
}; // MA
//+------------------------------------------------------------------+
//| Buffer defintion functions                                       |
//+------------------------------------------------------------------+
enum  Wingding {           WD_THUMBSUP=67,               WD_THUMBSDOWN,
   WD_DOT_LARGE=108,       WD_SQUARE_FILLED_MEDIUM=110,  WD_SQUARE_EMPTY_MEDIUM,
   WD_DIAMOND_SMALL=115,   WD_DIAMOND_LARGE,WD_SQUARE_FILLED_MEDIUM_ROTATED=117,
   WD_SQUARE_FILLED_SMALL_ROTATED=119,                   WD_CIRCLE_EMPTY_0=128,
   WD_CIRCLE_EMPTY_1,      WD_CIRCLE_EMPTY_2,            WD_CIRCLE_EMPTY_3,
   WD_CIRCLE_EMPTY_4,      WD_CIRCLE_EMPTY_5,            WD_CIRCLE_EMPTY_6,
   WD_CIRCLE_EMPTY_7,      WD_CIRCLE_EMPTY_8,            WD_CIRCLE_EMPTY_9,
   WD_CIRCLE_EMPTY_10,     WD_CIRCLE_FILLED_0,           WD_CIRCLE_FILLED_1,
   WD_CIRCLE_FILLED_2,     WD_CIRCLE_FILLED_3,           WD_CIRCLE_FILLED_4,
   WD_CIRCLE_FILLED_5,     WD_CIRCLE_FILLED_6,           WD_CIRCLE_FILLED_7,
   WD_CIRCLE_FILLED_8,     WD_CIRCLE_FILLED_9,           WD_CIRCLE_FILLED_10,
   WD_DOT_SMALL=158,       WD_DOT_MEDIAN,                WD_CIRCLED_DOT=164,
   WD_SQUARE_FILLED_SMALL=167,   WD_STAR_3=169,          WD_STAR_4,
   WD_STAR_5,              WD_STAR_6,                    WD_STAR_5_CIRCLED=181,
   WD_STAR_5_HOLLOW,       WD_ARROW_UP_THIN=225,         WD_ARROW_DN_THIN,
   WD_ARROW_UR_THIN=228,   WD_ARROW_DR_THIN=230,         WD_ARROW_UP_THICK=233,
   WD_ARROW_DN_THICK,      WD_ARROW_UR_THICK=236,        WD_ARROW_DR_THICK=238,
   WD_ARROW_UP_EMPTY=241,  WD_ARROW_DN_EMPTY,            WD_ARROW_UR_EMPTY=246,
   WD_ARROW_DR_EMPTY=248,  WD_SQUARE_EMPTY_SMALL=250,    WD_CROSS_SIGN,
   WD_CHECK_SIGN,          WD_CROSS_SIGN_BOX,            WD_CHECK_SIGN_BOX};
// Predefined in MT5 {DRAW_XXXX}. In Mt4, same value as DRAW_XXXX
enum  ENUM_DRAW_TYPE {  TYPE_LINE,     TYPE_SECTION,     TYPE_HISTOGRAM,
                        TYPE_ARROW,    TYPE_ZIGZAG,      TYPE_NONE=12   };
// ENUM_LINE_STYLE {    STYLE_SOLID,   STYLE_DASH,       STYLE_DOT,
//                      STYLE_DASHDOT, STYLE_DASHDOTDOT  };
const string   NO_DATA  = NULL;  // Buffer is not shown in the data window.
#define        NO_CHART CLR_NONE // Buffer is not shown on the chart.

bool SetBuffer(INDEX i,PRICE& b[], Wingding ac,string lab,PRICE ev=EMPTY_VALUE){
   SetIndexArrow(i,ac);                      return SetBuffer(i, b, lab, ev);  }
bool SetBuffer(INDEX i,PRICE& b[], Wingding ac,           PRICE ev=EMPTY_VALUE){
   SetIndexArrow(i,ac);                      return SetBuffer(i, b, ev);       }

bool SetBuffer(INDEX i,PRICE& b[], ENUM_DRAW_TYPE dt, ENUM_LINE_STYLE ls,
                                   COUNT wid,  string lab,PRICE ev=EMPTY_VALUE){
   SetIndexStyle(i, dt, ls, wid);            return SetBuffer(i, b, lab, ev);  }
bool SetBuffer(INDEX i,PRICE& b[], ENUM_DRAW_TYPE dt, ENUM_LINE_STYLE ls=EMPTY,
                                   COUNT wid=EMPTY,       PRICE ev=EMPTY_VALUE){
   SetIndexStyle(i, dt, ls, wid);            return SetBuffer(i, b, ev);       }
bool SetBuffer(INDEX i,PRICE& b[], ENUM_DRAW_TYPE dt, ENUM_LINE_STYLE ls,
                                               string lab,PRICE ev=EMPTY_VALUE){
   SetIndexStyle(i, dt, ls);                 return SetBuffer(i, b, lab, ev);  }
bool SetBuffer(INDEX i,PRICE& b[], ENUM_DRAW_TYPE dt,
                                   COUNT wid,  string lab,PRICE ev=EMPTY_VALUE){
   SetIndexStyle(i, dt, EMPTY, wid);         return SetBuffer(i, b, lab, ev);  }

bool SetBuffer(INDEX i,PRICE& b[],             string lab,PRICE ev=EMPTY_VALUE){
   SetIndexLabel(i, lab);                    return SetBuffer(i, b, ev);       }
bool SetBuffer(INDEX i,PRICE& b[],                        PRICE ev=EMPTY_VALUE){
   SetIndexEmptyValue(i, ev);                return SetIndexBuffer(i, b)
                                                && ArraySetAsSeries(b, true);  }
//+------------------------------------------------------------------+
//} Generic code                                                     |
//{ Specific code                                                    |
//+------------------------------------------------------------------+
//---- indicator parameters
input COUNT                LengthFast     = 50;          // Fast period
#define  CHECK_PARAM1      LengthFast >= 1
input ENUM_MA_METHOD       MethodFast     = MODE_SMA;    // Fast method
#define  CHECK_PARAM2      MethodFast != MODE_SMMA
/* Never any reason to use the SMMA(n) it's equivalent to the EMA(2n-1).
 * futures.io/ninjatrader-programming/8358-smoothed-moving-average-smma-how-
 * avoid.html The Smoothed Moving Average or SMMA - How to Avoid It -
 * NinjaTrader Programming | futures.io                                       */

input ENUM_APPLIED_PRICE   PriceFast      = PRICE_CLOSE; // Fast price

input COUNT                LengthSlow     = 200;         // Slow period
#define  CHECK_PARAM4      LengthSlow > LengthFast
input ENUM_MA_METHOD       MethodSlow     = MODE_SMA;    // Slow method
#define  CHECK_PARAM5      MethodFast != MODE_SMMA
input ENUM_APPLIED_PRICE   PriceSlow      = PRICE_CLOSE; // Slow price

input COUNT                LengthSignal   = 9;     // MACD Signal length.
#define  CHECK_PARAM7      LengthSignal > 1
//---- indicator buffers
#property   indicator_chart_window
#property   indicator_buffers    10
#define     AVE_FAST    MethodFast==MODE_SMA ? "" : as_string(MethodFast,1)
#define     AVE_SLOW    MethodSlow==MODE_SMA ? "" : as_string(MethodSlow,1)
#define     SHORTNAME StringFormat("MArib(%i%s/%i%s,%i)",                     \
                                                      LengthFast, AVE_FAST,   \
                                                      LengthSlow, AVE_SLOW,   \
                                                      LengthSignal)
//#property indicator_type1   DRAW_LINE                  // Bug 1090 must set.
//#property indicator_style1  STYLE_SOLID
//#property indicator_width1  1
//#property indicator_label1  "const"
//{ For data window, not shown on chart.
PRICE       bFast[];
#property   indicator_color1  NO_CHART
#define     MODE_FAST   as_string(MethodFast)
#define     PRICE_FAST  PriceFast == PRICE_CLOSE ? "" : as_string(PriceFast)
#define     LABEL_FAST  StringFormat("%s(%i%s)",MODE_FAST,LengthFast,PRICE_FAST)
#define     INDICATOR_BUFFER1 bFast,LABEL_FAST

PRICE       bSlow[];
#property   indicator_color2  NO_CHART
#define     MODE_SLOW   as_string(MethodSlow)
#define     PRICE_SLOW  PriceSlow == PRICE_CLOSE ? "" : as_string(PriceSlow)
#define     LABEL_SLOW  StringFormat("%s(%i%s)",MODE_SLOW,LengthSlow,PRICE_SLOW)
#define     INDICATOR_BUFFER2 bSlow,LABEL_SLOW
//} For data window, not shown on chart.
//{ Shown on chart
//{ Shown on chart, not in data window.
PRICE       bRibbonFast[];
#property   indicator_color3  Lime
#property   indicator_type3   DRAW_HISTOGRAM
#property   indicator_style3  STYLE_DOT
#define     INDICATOR_BUFFER3 bRibbonFast,NO_DATA

PRICE       bRibbonSlow[];
#property   indicator_color4  Red
#property   indicator_type4   DRAW_HISTOGRAM
#property   indicator_style4  STYLE_DOT
#define     INDICATOR_BUFFER4 bRibbonSlow,NO_DATA

PRICE       bFastUp[];
#property   indicator_type5   DRAW_LINE                  // Bug 1090 must set.
#property   indicator_style5  STYLE_SOLID
#property   indicator_width5  1
#property   indicator_color5  Lime
#define     INDICATOR_BUFFER5 bFastUp,NO_DATA

PRICE       bFastDn[];
#property   indicator_type6   DRAW_LINE      // Bug 1090 must set.
#property   indicator_style6  STYLE_SOLID
#property   indicator_width6  1
#property   indicator_color6  Red
#define     INDICATOR_BUFFER6 bFastDn,NO_DATA

PRICE       bFastFl[];
#property   indicator_type7   DRAW_LINE      // Bug 1090 must set.
#property   indicator_style7  STYLE_SOLID
#property   indicator_width7  1
#property   indicator_color7  Yellow
#define     INDICATOR_BUFFER7 bFastFl,NO_DATA

PRICE       bSlowDn[];
#property   indicator_type8   DRAW_LINE      // Bug 1090 must set.
#property   indicator_style8  STYLE_SOLID
#property   indicator_width8  2
#property   indicator_color8  Red
#define     INDICATOR_BUFFER8 bSlowDn,NO_DATA

PRICE       bSlowUp[];
#property   indicator_type9   DRAW_LINE      // Bug 1090 must set.
#property   indicator_style9  STYLE_SOLID
#property   indicator_width9  2
#property   indicator_color9  Lime
#define     INDICATOR_BUFFER9 bSlowUp,NO_DATA

PRICE       bSlowFl[];
#property   indicator_type10  DRAW_LINE      // Bug 10100 must set.
#property   indicator_style10 STYLE_SOLID
#property   indicator_width10 2
#property   indicator_color10 Yellow
#define     INDICATOR_BUFFER10 bSlowFl,NO_DATA
//} Shown on chart, not in data window.
//} Shown on chart
//{ extra buffers, not shown anywhere.
//#define      BUFFERS_COUNT_TOTAL  11                                  // Extra
//} extra buffers, not shown anywhere.
//+------------------------------------------------------------------+
//} Specific code                                                    |
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(){
   if(IS_DEBUG_MODE) Print("buffers");
   IndicatorDigits(_Digits);                             // Default is 4
#ifdef   SHORTNAME
   IndicatorSetString(INDICATOR_SHORTNAME, SHORTNAME);
#endif
#ifdef   BUFFERS_COUNT_TOTAL
   IndicatorBuffers(BUFFERS_COUNT_TOTAL);
#endif
// Stringize only valid in a macro (build 1090.)
#define  CHECK_PARAM(x) if(!(x)){   alert_id(#x);                             \
                                    return INIT_PARAMETERS_INCORRECT;   }
#ifdef   CHECK_PARAM1
   CHECK_PARAM(CHECK_PARAM1);
#endif
#ifdef   CHECK_PARAM2
   CHECK_PARAM(CHECK_PARAM2);
#endif
#ifdef   CHECK_PARAM3
   CHECK_PARAM(CHECK_PARAM3);
#endif
#ifdef   CHECK_PARAM4
   CHECK_PARAM(CHECK_PARAM4);
#endif
#ifdef   CHECK_PARAM5
   CHECK_PARAM(CHECK_PARAM5);
#endif
#ifdef   CHECK_PARAM6
   CHECK_PARAM(CHECK_PARAM6);
#endif
#ifdef   CHECK_PARAM7
   CHECK_PARAM(CHECK_PARAM7);
#endif
#ifdef   CHECK_PARAM8
   CHECK_PARAM(CHECK_PARAM8);
#endif
#ifdef   CHECK_PARAM9
   CHECK_PARAM(CHECK_PARAM9);
#endif
#ifdef   CHECK_PARAM10
   CHECK_PARAM(CHECK_PARAM10);
#endif
#ifdef   CHECK_PARAM11
   CHECK_PARAM(CHECK_PARAM11);
#endif
#ifdef   INDICATOR_BUFFER1
   if(!SetBuffer(1-1,INDICATOR_BUFFER1) ){
      alert_id(StringFormat("B1:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER2
   if(!SetBuffer(2-1,INDICATOR_BUFFER2) ){
      alert_id(StringFormat("B2:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER3
   if(!SetBuffer(3-1,INDICATOR_BUFFER3) ){
      alert_id(StringFormat("B3:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER4
   if(!SetBuffer(4-1,INDICATOR_BUFFER4) ){
      alert_id(StringFormat("B4:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER5
   if(!SetBuffer(5-1,INDICATOR_BUFFER5) ){
      alert_id(StringFormat("B5:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER6
   if(!SetBuffer(6-1,INDICATOR_BUFFER6) ){
      alert_id(StringFormat("B6:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER7
   if(!SetBuffer(7-1,INDICATOR_BUFFER7) ){
      alert_id(StringFormat("B7:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER8
   if(!SetBuffer(8-1,INDICATOR_BUFFER8) ){
      alert_id(StringFormat("B8:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER9
   if(!SetBuffer(9-1,INDICATOR_BUFFER9) ){
      alert_id(StringFormat("B9:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER10
   if(!SetBuffer(10-1,INDICATOR_BUFFER10) ){
      alert_id(StringFormat("B10:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER11
   if(!SetBuffer(11-1,INDICATOR_BUFFER11) ){
      alert_id(StringFormat("B11:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER12
   if(!SetBuffer(12-1,INDICATOR_BUFFER12) ){
      alert_id(StringFormat("B12:%i", _LastError) );     return INIT_FAILED;  }
#endif
   if(IS_DEBUG_MODE) Print("init ok");
   return INIT_SUCCEEDED;
}  // OnInit
//+------------------------------------------------------------------+
//| Custom indicator de-initialization function                      |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
MA    gFastLine(MethodFast, LengthFast, PriceFast),
      gSlowLine(MethodSlow, LengthSlow, PriceSlow);
   #define  ATRlength         14
ATR   gATR(ATRlength);
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]){
   #define  LAST              0                       // Draw bar zero?
   #define  REDRAW_BAR_LAST   (LAST == 0)             // Redraw bar last.
   #define  LBatr    ATRlength - 1
   #define  LBfast   int(LengthFast) - 1
   #define  LBslow   int(LengthSlow) - 1
   #define  LBribn   MathMax(LBslow, LBatr)
   #define  LBmacd   LBslow + int(LengthSignal) - 1
   int      iMacd    = rates_total - MathMax(LBmacd, prev_calculated);
   int      iRibn    = rates_total - MathMax(LBribn, prev_calculated);
   int      iSlow    = rates_total - MathMax(LBslow, prev_calculated);
   int      iBar     = rates_total - MathMax(LBfast, prev_calculated);
   while(iBar > LAST){  --iBar;
      PRICE    fastLine  = bFast[iBar] = gFastLine.get(iBar);

      if(iBar >= iSlow) continue;
      PRICE    slowLine  = bSlow[iBar] = gSlowLine.get(iBar);

      if(iBar < iMacd){                // Color MAs depending on MACD vs Signal.
         double   MACD=0,  signal   = 0.0;
         for(int  iLast = iBar + (int)LengthSignal; iLast > iBar;){  --iLast;
            MACD  = bFast[iLast] - bSlow[iLast];   signal  += MACD;           }
         signal   /= LengthSignal;

         bFastUp[iBar]  = bSlowUp[iBar]   = bFastFl[iBar]   =
         bFastDn[iBar]  = bSlowDn[iBar]   = bSlowFl[iBar]   = EMPTY_VALUE;
         if(      MACD > 0 && MACD > signal){
            bFastUp[iBar]  = fastLine;          bSlowUp[iBar]  = slowLine;
            if(bSlowUp[iBar+1] == EMPTY_VALUE)  bSlowUp[iBar+1] = bSlow[iBar+1];
            if(bFastUp[iBar+1] == EMPTY_VALUE)  bFastUp[iBar+1] = bFast[iBar+1];
         }else if(MACD < 0 && MACD < signal){
            bFastDn[iBar]  = fastLine;          bSlowDn[iBar]  = slowLine;
            if(bSlowDn[iBar+1] == EMPTY_VALUE)  bSlowDn[iBar+1] = bSlow[iBar+1];
            if(bFastDn[iBar+1] == EMPTY_VALUE)  bFastDn[iBar+1] = bFast[iBar+1];
         }else{
            bFastFl[iBar]  = fastLine;          bSlowFl[iBar]  = slowLine;
            if(bSlowFl[iBar+1] == EMPTY_VALUE)  bSlowFl[iBar+1] = bSlow[iBar+1];
            if(bFastFl[iBar+1] == EMPTY_VALUE)  bFastFl[iBar+1] = bFast[iBar+1];
         }
      }                                // Color MAs depending on MACD vs Signal.

      if(iBar < iRibn && iBar != 0){   // Color the ribbon. Don't overlap price.
         bool     isUptrend   = fastLine > slowLine;
         if(!isUptrend) swap(fastLine, slowLine);
            CHANGE   atr   = gATR.get(iBar);
         PRICE f1 = fastLine,
               s1 = MathMin(fastLine, MathMax(slowLine, High[iBar] + atr) );
         PRICE s2 = slowLine,
               f2 = MathMax(slowLine, MathMin(fastLine,  Low[iBar] - atr) );
         if(f1-s1 < f2-s2){   swap(f1,f2);   swap(s1,s2);   }
         if(f1-s1 > 0){
            if(!isUptrend)    swap(f1,s1);
            bRibbonFast[iBar] = f1;    bRibbonSlow[iBar] = s1;
         }
      }                                // Color the ribbon. Don't overlap price.
   }  // iBar
   //----
   return rates_total-iBar-REDRAW_BAR_LAST;
}  // OnCalculate
//+------------------------------------------------------------------+
